unit Hlavni;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, xmldom, XMLIntf, msxmldom, XMLDoc,
  oxmldom;

type
  TFMain = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    SNoty: TScrollBar;
    XML: TXMLDocument;
    ODialog: TOpenDialog;
    PNoty: TPanel;
    INoty: TImage;
    Uloit1: TMenuItem;
    Uloitjako1: TMenuItem;
    SDialog: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure Linkuj;
    procedure DrawBitmap(X, Y : Integer; NotaStr : String; Nahoru : Boolean);
    procedure DrawNota(X : Integer; Vyska : String; Doba : Real);
    procedure Nota(Delka : Real; Vyska : String);
    procedure DrawMezera(X : Integer; Doba : Real);
    procedure Mezera(Delka : Real);
    procedure Otevt1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SNotyChange(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Uloitjako1Click(Sender: TObject);
  private
    { Private declarations }
    Cesta {sloka, kde se nachz program}, FileName {prv oteven soubor} : String;
    DobaTaktu {vyerpan st taktu} : Real;
    Position {slou k posouvn not}, DelkaTaktu {dlka taktu: 3, 4, 5} : Integer;
  public
    { Public declarations }
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}

procedure TFMain.FormCreate(Sender: TObject);
 begin
  Cesta:=ExtractFilePath(ParamStr(0));
  FileName:='';
end;

procedure TFMain.Linkuj;
 var
  Line : Integer;
 begin
  for Line:=0 to 4 do //nakresl notovou osnovu
   begin
    INoty.Picture.Bitmap.Canvas.MoveTo(0, 16+8*Line);
    INoty.Picture.Bitmap.Canvas.LineTo(INoty.Picture.Bitmap.Width, 16+8*Line);
   end;
end;

procedure TFMain.DrawBitmap(X, Y : Integer; NotaStr : String; Nahoru : Boolean);
 var
  Nota : TBitmap;
 begin
  Nota:=TBitmap.Create; //vykresl do osnovy uritou bitmapu
  Nota.LoadFromFile(Cesta+'Noty\'+NotaStr);
  if Nahoru //zarovn podle vrchn nebo spodn hrany
   then INoty.Picture.Bitmap.Canvas.Draw(X, Y-Nota.Height, Nota)
   else INoty.Picture.Bitmap.Canvas.Draw(X, Y, Nota);
  Nota.Free;
  Linkuj;
end;

procedure TFMain.DrawNota(X : Integer; Vyska : String; Doba : Real);
 var
  NotaStr : String;
  Y : Integer;
 begin
  if (Vyska = 'C') or (Vyska = 'c') or (Vyska = 'Cis') or (Vyska = 'cis') then
   Y:=0;
  if (Vyska = 'D') or (Vyska = 'd') or (Vyska = 'Dis') or (Vyska = 'dis') then
   Y:=1;
  if (Vyska = 'E') or (Vyska = 'e') then
   Y:=2;
  if (Vyska = 'F') or (Vyska = 'f') or (Vyska = 'Fis') or (Vyska = 'fis') then
   Y:=3;
  if (Vyska = 'G') or (Vyska = 'g') or (Vyska = 'Gis') or (Vyska = 'gis') then
   Y:=4;
  if (Vyska = 'A') or (Vyska = 'a') or (Vyska = 'Ais') or (Vyska = 'ais') then
   Y:=5;
  if (Vyska = 'H') or (Vyska = 'h') then
   Y:=6;
  INoty.Picture.Bitmap.Canvas.Brush.Color:=clBlack;
  if (Vyska = 'C') or (Vyska = 'D') or (Vyska = 'E') or (Vyska = 'F') or (Vyska = 'G') or (Vyska = 'A') or (Vyska = 'H') then
   begin
    Y:=16+6*8-Y*4;
    if Doba = 0.5 then
     NotaStr:='nota_nahoru_0.bmp';
    if Doba = 1 then
     NotaStr:='nota_nahoru_1.bmp';
    if Doba = 1.5 then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2-5, X+2+20, Y+2-5);
      NotaStr:='nota_nahoru_1.bmp';
     end;
    if Doba = 2 then
     NotaStr:='nota_nahoru_2.bmp';
    if Doba = 3then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2-5, X+2+20, Y+2-5);
      NotaStr:='nota_nahoru_2.bmp';
     end;
    if Doba = 4 then
     NotaStr:='nota_4.bmp';
    DrawBitmap(X, Y, NotaStr, True);
   end;
  if (Vyska = 'c') or (Vyska = 'd') or (Vyska = 'e') or (Vyska = 'f') or (Vyska = 'g') or (Vyska = 'a') or (Vyska = 'h') then
   begin
    Y:=16+1*8-Y*4;
    if Doba = 0.5 then
     NotaStr:='nota_dolu_0.bmp';
    if Doba = 1 then
     NotaStr:='nota_dolu_1.bmp';
    if Doba = 1.5 then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2+5, X+2+20, Y+2+5);
      NotaStr:='nota_dolu_1.bmp';
     end;
    if Doba = 2 then
     NotaStr:='nota_dolu_2.bmp';
    if Doba = 3then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2+5, X+2+20, Y+2+5);
      NotaStr:='nota_dolu_2.bmp';
     end;
    if Doba = 4 then
     NotaStr:='nota_4.bmp';
    DrawBitmap(X, Y, NotaStr, False);
   end;
  if (Vyska = 'Cis') or (Vyska = 'Dis')  or (Vyska = 'Fis') or (Vyska = 'Gis') or (Vyska = 'Ais') then
   begin
    Y:=16+6*8-Y*4;
    if Doba = 0.5 then
     NotaStr:='nota_krizek_nahoru_0.bmp';
    if Doba = 1 then
     NotaStr:='nota_krizek_nahoru_1.bmp';
    if Doba = 1.5 then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2-5, X+2+20, Y+2-5);
      NotaStr:='nota_krizek_nahoru_1.bmp';
     end;
    if Doba = 2 then
     NotaStr:='nota_krizek_nahoru_2.bmp';
    if Doba = 3then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2-5, X+2+20, Y+2-5);
      NotaStr:='nota_krizek_nahoru_2.bmp';
     end;
    if Doba = 4 then
     NotaStr:='nota_krizek_4.bmp';
    DrawBitmap(X, Y+8, NotaStr, True);
   end;
  if (Vyska = 'cis') or (Vyska = 'dis')  or (Vyska = 'fis') or (Vyska = 'gis') or (Vyska = 'ais') then
   begin
    Y:=16+1*8-Y*4;
    if Doba = 0.5 then
     NotaStr:='nota_krizek_dolu_0.bmp';
    if Doba = 1 then
     NotaStr:='nota_krizek_dolu_1.bmp';
    if Doba = 1.5 then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2-5, X+2+20, Y+2-5);
      NotaStr:='nota_krizek_dolu_1.bmp';
     end;
    if Doba = 2 then
     NotaStr:='nota_krizek_dolu_2.bmp';
    if Doba = 3then
     begin
      INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2-5, X+2+20, Y+2-5);
      NotaStr:='nota_krizek_dolu_2.bmp';
     end;
    if Doba = 4 then
     NotaStr:='nota_krizek_4.bmp';
    DrawBitmap(X, Y-8, NotaStr, False);
   end;
  if (Vyska = 'C') or (Vyska = 'Cis') then
   begin
    INoty.Picture.Bitmap.Canvas.MoveTo(X-5, 16+5*8);
    INoty.Picture.Bitmap.Canvas.LineTo(X+20, 16+5*8);
   end;
  if (Vyska = 'a') or (Vyska = 'ais') or (Vyska = 'h') then
   begin
    INoty.Picture.Bitmap.Canvas.MoveTo(X-5, 16-8);
    INoty.Picture.Bitmap.Canvas.LineTo(X+20, 16-8);
   end;
end;

procedure TFMain.Nota(Delka : Real; Vyska : String);
 var
  Cast : Real;
 begin
  INoty.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
  INoty.Picture.Bitmap.Width:=55+(Position+1)*30;
  if DobaTaktu + Delka <= DelkaTaktu then // kdy se vejde do taktu
   begin
    DrawNota(55+Position*30, Vyska, Delka);
    Inc(Position);
    DobaTaktu:=DobaTaktu+Delka;
    if DobaTaktu = DelkaTaktu then // kdy je takt pln
     begin
      INoty.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
      INoty.Picture.Bitmap.Width:=55+(Position+1)*30;
      INoty.Picture.Bitmap.Canvas.MoveTo(55+Position*30+11, 16);
      INoty.Picture.Bitmap.Canvas.LineTo(55+Position*30+11, 16+4*8);
      Inc(Position);
      DobaTaktu:=0;
     end;
   end
   else // kdy se nevejde
    begin
     Cast:=DelkaTaktu - DobaTaktu;
     DrawNota(55+Position*30, Vyska, Cast);// vykresl st, kter se vejde
     Inc(Position);
     INoty.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
     INoty.Picture.Bitmap.Width:=55+(Position+1)*30; // uzave takt
     INoty.Picture.Bitmap.Canvas.MoveTo(55+Position*30+11, 16);
     INoty.Picture.Bitmap.Canvas.LineTo(55+Position*30+11, 16+4*8);
     Inc(Position);
     DobaTaktu:=0;
     Nota(Delka - Cast, Vyska); // rekurze pro zbytek
    end;
end;

procedure TFMain.DrawMezera(X : Integer; Doba : Real);
 var
  NotaStr : String;
  Y : Integer;
 begin
  INoty.Picture.Bitmap.Canvas.Brush.Color:=clBlack;
  if Doba = 0.5 then
   begin
    Y:=16+8;
    NotaStr:='pomlka_0.bmp';
   end; 
  if Doba = 1 then
   begin
    Y:=16+8-3;
    NotaStr:='pomlka_1.bmp';
   end;
  if Doba = 1.5 then
   begin
    Y:=16+8-3;
    INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2+8, X+2+20, Y+2+8);
    NotaStr:='pomlka_1.bmp';
   end;
  if Doba = 2 then
   begin
    Y:=16+8+3;
    NotaStr:='pomlka_2.bmp';
   end;
  if Doba = 3 then
   begin
    Y:=16+8+3;
    INoty.Picture.Bitmap.Canvas.Ellipse(X-2+20, Y-2+2, X+2+20, Y+2+2);
    NotaStr:='pomlka_2.bmp';
   end;
  if Doba = 4 then
   begin
    Y:=16+8;
    NotaStr:='pomlka_4.bmp';
   end;
  DrawBitmap(X, Y, NotaStr, False);
end;

procedure TFMain.Mezera(Delka : Real);
 var
  Cast : Real;
 begin
  INoty.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
  INoty.Picture.Bitmap.Width:=55+(Position+1)*30;
  if DobaTaktu + Delka <= DelkaTaktu then // kdy se vejde do taktu
   begin
    DrawMezera(55+Position*30, Delka);
    Inc(Position);
    DobaTaktu:=DobaTaktu+Delka;
    if DobaTaktu = DelkaTaktu then // kdy je takt pln
     begin
      INoty.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
      INoty.Picture.Bitmap.Width:=55+(Position+1)*30; // uzave takt
      INoty.Picture.Bitmap.Canvas.MoveTo(55+Position*30+11, 16);
      INoty.Picture.Bitmap.Canvas.LineTo(55+Position*30+11, 16+4*8);
      Inc(Position);
      DobaTaktu:=0;
     end;
   end
   else // kdy se nevejde do taktu
    begin
     Cast:=DelkaTaktu - DobaTaktu;
     DrawMezera(55+Position*30, Cast); // zape tolik, kolik se vejde
     Inc(Position);
     INoty.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
     INoty.Picture.Bitmap.Width:=55+(Position+1)*30;
     INoty.Picture.Bitmap.Canvas.MoveTo(55+Position*30+11, 16);
     INoty.Picture.Bitmap.Canvas.LineTo(55+Position*30+11, 16+4*8);
     Inc(Position);
     DobaTaktu:=0;
     Mezera(Delka - Cast); // rekurze pro zbylou st
    end;
end;

procedure TFMain.Otevt1Click(Sender: TObject);
 var
  Takt, DelkaStr : String;
  NotaC : Integer;
  Node : IXMLNode;
 begin
  if ODialog.Execute then
   begin
    XML.LoadFromFile(ODialog.FileName); //oteve soubor
    Filename:=ODialog.FileName;
    if (XML.ChildNodes[0].NodeName = 'skladba') and (XML.ChildNodes[0].HasAttribute('takt')) then
     begin
      INoty.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
      INoty.Picture.Bitmap.Height:=65;
      INoty.Picture.Bitmap.Width:=55;
      DrawBitmap(5, 65, 'klic.bmp', True);
      Takt:=XML.ChildNodes[0].GetAttributeNS('takt', '');
      DelkaTaktu:=StrToInt(Takt[1]);
      case DelkaTaktu of //zape takt
       3 : DrawBitmap(33, 48, 'takt_3.bmp', True);
       4 : DrawBitmap(33, 48, 'takt_4.bmp', True);
       5 : DrawBitmap(33, 48, 'takt_5.bmp', True);
      end;
      DobaTaktu:=0;
      Position:=0;
      for NotaC:=0 to XML.ChildNodes[0].ChildNodes.Count-1 do
       begin
        Node:=XML.ChildNodes[0].ChildNodes[NotaC];
        if Node.LocalName = 'nota' then
         begin //pete notu
          DelkaStr:=Node.Attributes['delka'];
          DelkaStr[Pos('.', DelkaStr)]:=',';
          Nota(StrToFloat(DelkaStr), Node.Attributes['vyska']);
         end;
        if Node.LocalName = 'pomlka' then
         begin //pete pomlku
          DelkaStr:=Node.Attributes['delka'];
          DelkaStr[Pos('.', DelkaStr)]:=',';
          Mezera(StrToFloat(DelkaStr));
         end;
       end;
      Linkuj; 
     end;
   end;
  FormResize(Sender);
end;

procedure TFMain.FormResize(Sender: TObject);
 begin
  SNoty.Max:=(INoty.Width div PNoty.Width + 1) * PNoty.Width;
end;

procedure TFMain.SNotyChange(Sender: TObject);
 begin
  INoty.Left:=(-PNoty.Width*SNoty.Position) div PNoty.Width; //posunuje osnovu
end;

procedure TFMain.Uloit1Click(Sender: TObject);
 begin
  if FileName = '' then //pokud nen oteven soubor
   begin
    Uloitjako1Click(Sender); //vyvol uloit jako
    Exit;
   end;
  XML.SaveToFile(FileName);
end;

procedure TFMain.Uloitjako1Click(Sender: TObject);
 begin
  if SDialog.Execute then
   begin
    XML.SaveToFile(SDialog.FileName);
    Filename:=SDialog.FileName;
   end;
end;

end.
